commit a0c233bf805e2301c67e23397e61aab33c63f07c
Author: freddy77 <freddy77>
Date:   Wed Jun 10 18:54:38 2009 +0000

    move blob check to odbc_tds2sql

diff --git a/ChangeLog b/ChangeLog
index 8d7cea0..e973916 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Wed Jun 10 20:54:07 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/convert_tds2sql.c src/odbc/odbc.c src/odbc/odbc_util.c:
+	- move blob check to odbc_tds2sql
+
 Wed Jun 10 18:44:48 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/ctlib/ct.c: limit indentation
 
@@ -1638,4 +1642,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2811 2009/06/10 16:44:56 freddy77 Exp $
+$Id: ChangeLog,v 1.2812 2009/06/10 18:54:38 freddy77 Exp $
diff --git a/src/odbc/convert_tds2sql.c b/src/odbc/convert_tds2sql.c
index 2ac12f8..fb8b928 100644
--- a/src/odbc/convert_tds2sql.c
+++ b/src/odbc/convert_tds2sql.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.62 2008/10/24 05:37:19 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.63 2009/06/10 18:54:38 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -153,6 +153,15 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 
 	assert(desttype != SQL_C_DEFAULT);
 
+	if (curcol) {
+		if (is_blob_col(curcol))
+			src = ((TDSBLOB *) src)->textvalue;
+		if (is_variable_type(curcol->column_type)) {
+			src += curcol->column_text_sqlgetdatapos;
+			srclen -= curcol->column_text_sqlgetdatapos;
+		}
+	}
+
 	nDestSybType = odbc_c_to_server_type(desttype);
 	if (nDestSybType == TDS_FAIL) {
 		odbc_errs_add(&stmt->errs, "HY003", NULL);
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 78d7401..e7ba3a6 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.511 2009/05/28 16:23:32 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.512 2009/06/10 18:54:38 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -3655,9 +3655,8 @@ _SQLFetch(TDS_STMT * stmt, SQLSMALLINT FetchOrientation, SQLLEN FetchOffset)
 				TDS_CHAR *data_ptr = (TDS_CHAR *) drec_ard->sql_desc_data_ptr;
 
 				src = (TDS_CHAR *) colinfo->column_data;
-				if (is_blob_col(colinfo))
-					src = ((TDSBLOB *) src)->textvalue;
 				srclen = colinfo->column_cur_size;
+				colinfo->column_text_sqlgetdatapos = 0;
 				c_type = drec_ard->sql_desc_concise_type;
 				if (c_type == SQL_C_DEFAULT)
 					c_type = odbc_sql_to_c_type_default(stmt->ird->records[i].sql_desc_concise_type);
@@ -4652,11 +4651,8 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 	TDSCOLUMN *colinfo;
 	TDSRESULTINFO *resinfo;
 	TDSSOCKET *tds;
-	TDS_CHAR *src;
-	int srclen;
 	TDSCONTEXT *context;
 	SQLLEN dummy_cb;
-	int nSybType;
 
 	INIT_HSTMT;
 
@@ -4700,25 +4696,19 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 		/* TODO check what should happen if pcbValue was NULL */
 		*pcbValue = SQL_NULL_DATA;
 	} else {
+		TDS_CHAR *src;
+		int srclen;
+		int nSybType;
+
+		if (colinfo->column_text_sqlgetdatapos > 0
+		    && colinfo->column_text_sqlgetdatapos >= colinfo->column_cur_size)
+			ODBC_RETURN(stmt, SQL_NO_DATA);
+
 		src = (TDS_CHAR *) colinfo->column_data;
-		if (is_variable_type(colinfo->column_type)) {
-			if (colinfo->column_text_sqlgetdatapos > 0
-			    && colinfo->column_text_sqlgetdatapos >= colinfo->column_cur_size)
-				ODBC_RETURN(stmt, SQL_NO_DATA);
-
-			/* 2003-8-29 check for an old bug -- freddy77 */
-			assert(colinfo->column_text_sqlgetdatapos >= 0);
-			if (is_blob_col(colinfo))
-				src = ((TDSBLOB *) src)->textvalue;
-			src += colinfo->column_text_sqlgetdatapos;
-			srclen = colinfo->column_cur_size - colinfo->column_text_sqlgetdatapos;
-		} else {
-			if (colinfo->column_text_sqlgetdatapos > 0
-			    && colinfo->column_text_sqlgetdatapos >= colinfo->column_cur_size)
-				ODBC_RETURN(stmt, SQL_NO_DATA);
+		srclen = colinfo->column_cur_size;
+		if (!is_variable_type(colinfo->column_type))
+			colinfo->column_text_sqlgetdatapos = 0;
 
-			srclen = colinfo->column_cur_size;
-		}
 		nSybType = tds_get_conversion_type(colinfo->on_server.column_type, colinfo->on_server.column_size);
 		if (fCType == SQL_C_DEFAULT)
 			fCType = odbc_sql_to_c_type_default(stmt->ird->records[icol - 1].sql_desc_concise_type);
diff --git a/src/odbc/odbc_util.c b/src/odbc/odbc_util.c
index 641b5e8..2665bda 100644
--- a/src/odbc/odbc_util.c
+++ b/src/odbc/odbc_util.c
@@ -39,7 +39,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc_util.c,v 1.107 2009/05/28 16:23:32 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc_util.c,v 1.108 2009/06/10 18:54:38 freddy77 Exp $");
 
 /**
  * \ingroup odbc_api
@@ -209,8 +209,7 @@ odbc_set_return_params(struct _hstmt *stmt, unsigned int n_row)
 		}
 
 		src = (TDS_CHAR *) colinfo->column_data;
-		if (is_blob_col(colinfo))
-			src = ((TDSBLOB *) src)->textvalue;
+		colinfo->column_text_sqlgetdatapos = 0;
 		srclen = colinfo->column_cur_size;
 		c_type = drec_apd->sql_desc_concise_type;
 		if (c_type == SQL_C_DEFAULT)

